﻿using System;
using System.Text;

namespace plexdata.CodePage
{
    [Serializable]
    public class ASCIIDOSLatinUS : plexdata.CodePage.ASCIICodePageBase
    {
        public ASCIIDOSLatinUS()
            : base(437, "ASCII DOS Latin US (CP437)")
        {
        }

        protected override void InitCharacterTable()
        {
            // See also: http://de.wikipedia.org/wiki/Codepage_437
            // ftp://ftp.unicode.org/Public/MAPPINGS/VENDORS/MICSFT/PC/CP437.TXT

            #region Create character mapping table.

            this.theTable = new char[256];

            this.theTable[0x00] = '\u0000';  // NULL
            this.theTable[0x01] = '\u263A';  // START OF HEADING
            this.theTable[0x02] = '\u263B';  // START OF TEXT
            this.theTable[0x03] = '\u2665';  // END OF TEXT
            this.theTable[0x04] = '\u2666';  // END OF TRANSMISSION
            this.theTable[0x05] = '\u2663';  // ENQUIRY
            this.theTable[0x06] = '\u2660';  // ACKNOWLEDGE
            this.theTable[0x07] = '\u2022';  // BELL
            this.theTable[0x08] = '\u25D8';  // BACKSPACE
            this.theTable[0x09] = '\u25CB';  // HORIZONTAL TABULATION
            this.theTable[0x0A] = '\u25D9';  // LINE FEED
            this.theTable[0x0B] = '\u2642';  // VERTICAL TABULATION
            this.theTable[0x0C] = '\u2640';  // FORM FEED
            this.theTable[0x0D] = '\u266A';  // CARRIAGE RETURN
            this.theTable[0x0E] = '\u266B';  // SHIFT OUT
            this.theTable[0x0F] = '\u263C';  // SHIFT IN
            this.theTable[0x10] = '\u25BA';  // DATA LINK ESCAPE
            this.theTable[0x11] = '\u25C4';  // DEVICE CONTROL ONE
            this.theTable[0x12] = '\u2195';  // DEVICE CONTROL TWO
            this.theTable[0x13] = '\u203C';  // DEVICE CONTROL THREE
            this.theTable[0x14] = '\u00B6';  // DEVICE CONTROL FOUR
            this.theTable[0x15] = '\u00A7';  // NEGATIVE ACKNOWLEDGE
            this.theTable[0x16] = '\u25AC';  // SYNCHRONOUS IDLE
            this.theTable[0x17] = '\u21A8';  // END OF TRANSMISSION BLOCK
            this.theTable[0x18] = '\u2191';  // CANCEL
            this.theTable[0x19] = '\u2193';  // END OF MEDIUM
            this.theTable[0x1A] = '\u2192';  // SUBSTITUTE
            this.theTable[0x1B] = '\u2190';  // ESCAPE
            this.theTable[0x1C] = '\u221F';  // FILE SEPARATOR
            this.theTable[0x1D] = '\u2194';  // GROUP SEPARATOR
            this.theTable[0x1E] = '\u25B2';  // RECORD SEPARATOR
            this.theTable[0x1F] = '\u25BC';  // UNIT SEPARATOR
            this.theTable[0x20] = '\u0020';  // SPACE
            this.theTable[0x21] = '\u0021';  // EXCLAMATION MARK
            this.theTable[0x22] = '\u0022';  // QUOTATION MARK
            this.theTable[0x23] = '\u0023';  // NUMBER SIGN
            this.theTable[0x24] = '\u0024';  // DOLLAR SIGN
            this.theTable[0x25] = '\u0025';  // PERCENT SIGN
            this.theTable[0x26] = '\u0026';  // AMPERSAND
            this.theTable[0x27] = '\u0027';  // APOSTROPHE
            this.theTable[0x28] = '\u0028';  // LEFT PARENTHESIS
            this.theTable[0x29] = '\u0029';  // RIGHT PARENTHESIS
            this.theTable[0x2A] = '\u002A';  // ASTERISK
            this.theTable[0x2B] = '\u002B';  // PLUS SIGN
            this.theTable[0x2C] = '\u002C';  // COMMA
            this.theTable[0x2D] = '\u002D';  // HYPHEN-MINUS
            this.theTable[0x2E] = '\u002E';  // FULL STOP
            this.theTable[0x2F] = '\u002F';  // SOLIDUS
            this.theTable[0x30] = '\u0030';  // DIGIT ZERO
            this.theTable[0x31] = '\u0031';  // DIGIT ONE
            this.theTable[0x32] = '\u0032';  // DIGIT TWO
            this.theTable[0x33] = '\u0033';  // DIGIT THREE
            this.theTable[0x34] = '\u0034';  // DIGIT FOUR
            this.theTable[0x35] = '\u0035';  // DIGIT FIVE
            this.theTable[0x36] = '\u0036';  // DIGIT SIX
            this.theTable[0x37] = '\u0037';  // DIGIT SEVEN
            this.theTable[0x38] = '\u0038';  // DIGIT EIGHT
            this.theTable[0x39] = '\u0039';  // DIGIT NINE
            this.theTable[0x3A] = '\u003A';  // COLON
            this.theTable[0x3B] = '\u003B';  // SEMICOLON
            this.theTable[0x3C] = '\u003C';  // LESS-THAN SIGN
            this.theTable[0x3D] = '\u003D';  // EQUALS SIGN
            this.theTable[0x3E] = '\u003E';  // GREATER-THAN SIGN
            this.theTable[0x3F] = '\u003F';  // QUESTION MARK
            this.theTable[0x40] = '\u0040';  // COMMERCIAL AT
            this.theTable[0x41] = '\u0041';  // LATIN CAPITAL LETTER A
            this.theTable[0x42] = '\u0042';  // LATIN CAPITAL LETTER B
            this.theTable[0x43] = '\u0043';  // LATIN CAPITAL LETTER C
            this.theTable[0x44] = '\u0044';  // LATIN CAPITAL LETTER D
            this.theTable[0x45] = '\u0045';  // LATIN CAPITAL LETTER E
            this.theTable[0x46] = '\u0046';  // LATIN CAPITAL LETTER F
            this.theTable[0x47] = '\u0047';  // LATIN CAPITAL LETTER G
            this.theTable[0x48] = '\u0048';  // LATIN CAPITAL LETTER H
            this.theTable[0x49] = '\u0049';  // LATIN CAPITAL LETTER I
            this.theTable[0x4A] = '\u004A';  // LATIN CAPITAL LETTER J
            this.theTable[0x4B] = '\u004B';  // LATIN CAPITAL LETTER K
            this.theTable[0x4C] = '\u004C';  // LATIN CAPITAL LETTER L
            this.theTable[0x4D] = '\u004D';  // LATIN CAPITAL LETTER M
            this.theTable[0x4E] = '\u004E';  // LATIN CAPITAL LETTER N
            this.theTable[0x4F] = '\u004F';  // LATIN CAPITAL LETTER O
            this.theTable[0x50] = '\u0050';  // LATIN CAPITAL LETTER P
            this.theTable[0x51] = '\u0051';  // LATIN CAPITAL LETTER Q
            this.theTable[0x52] = '\u0052';  // LATIN CAPITAL LETTER R
            this.theTable[0x53] = '\u0053';  // LATIN CAPITAL LETTER S
            this.theTable[0x54] = '\u0054';  // LATIN CAPITAL LETTER T
            this.theTable[0x55] = '\u0055';  // LATIN CAPITAL LETTER U
            this.theTable[0x56] = '\u0056';  // LATIN CAPITAL LETTER V
            this.theTable[0x57] = '\u0057';  // LATIN CAPITAL LETTER W
            this.theTable[0x58] = '\u0058';  // LATIN CAPITAL LETTER X
            this.theTable[0x59] = '\u0059';  // LATIN CAPITAL LETTER Y
            this.theTable[0x5A] = '\u005A';  // LATIN CAPITAL LETTER Z
            this.theTable[0x5B] = '\u005B';  // LEFT SQUARE BRACKET
            this.theTable[0x5C] = '\u005C';  // REVERSE SOLIDUS
            this.theTable[0x5D] = '\u005D';  // RIGHT SQUARE BRACKET
            this.theTable[0x5E] = '\u005E';  // CIRCUMFLEX ACCENT
            this.theTable[0x5F] = '\u005F';  // LOW LINE
            this.theTable[0x60] = '\u0060';  // GRAVE ACCENT
            this.theTable[0x61] = '\u0061';  // LATIN SMALL LETTER A
            this.theTable[0x62] = '\u0062';  // LATIN SMALL LETTER B
            this.theTable[0x63] = '\u0063';  // LATIN SMALL LETTER C
            this.theTable[0x64] = '\u0064';  // LATIN SMALL LETTER D
            this.theTable[0x65] = '\u0065';  // LATIN SMALL LETTER E
            this.theTable[0x66] = '\u0066';  // LATIN SMALL LETTER F
            this.theTable[0x67] = '\u0067';  // LATIN SMALL LETTER G
            this.theTable[0x68] = '\u0068';  // LATIN SMALL LETTER H
            this.theTable[0x69] = '\u0069';  // LATIN SMALL LETTER I
            this.theTable[0x6A] = '\u006A';  // LATIN SMALL LETTER J
            this.theTable[0x6B] = '\u006B';  // LATIN SMALL LETTER K
            this.theTable[0x6C] = '\u006C';  // LATIN SMALL LETTER L
            this.theTable[0x6D] = '\u006D';  // LATIN SMALL LETTER M
            this.theTable[0x6E] = '\u006E';  // LATIN SMALL LETTER N
            this.theTable[0x6F] = '\u006F';  // LATIN SMALL LETTER O
            this.theTable[0x70] = '\u0070';  // LATIN SMALL LETTER P
            this.theTable[0x71] = '\u0071';  // LATIN SMALL LETTER Q
            this.theTable[0x72] = '\u0072';  // LATIN SMALL LETTER R
            this.theTable[0x73] = '\u0073';  // LATIN SMALL LETTER S
            this.theTable[0x74] = '\u0074';  // LATIN SMALL LETTER T
            this.theTable[0x75] = '\u0075';  // LATIN SMALL LETTER U
            this.theTable[0x76] = '\u0076';  // LATIN SMALL LETTER V
            this.theTable[0x77] = '\u0077';  // LATIN SMALL LETTER W
            this.theTable[0x78] = '\u0078';  // LATIN SMALL LETTER X
            this.theTable[0x79] = '\u0079';  // LATIN SMALL LETTER Y
            this.theTable[0x7A] = '\u007A';  // LATIN SMALL LETTER Z
            this.theTable[0x7B] = '\u007B';  // LEFT CURLY BRACKET
            this.theTable[0x7C] = '\u007C';  // VERTICAL LINE
            this.theTable[0x7D] = '\u007D';  // RIGHT CURLY BRACKET
            this.theTable[0x7E] = '\u007E';  // TILDE
            this.theTable[0x7F] = '\u2302';  // DELETE
            this.theTable[0x80] = '\u00C7';  // LATIN CAPITAL LETTER C WITH CEDILLA
            this.theTable[0x81] = '\u00FC';  // LATIN SMALL LETTER U WITH DIAERESIS
            this.theTable[0x82] = '\u00E9';  // LATIN SMALL LETTER E WITH ACUTE
            this.theTable[0x83] = '\u00E2';  // LATIN SMALL LETTER A WITH CIRCUMFLEX
            this.theTable[0x84] = '\u00E4';  // LATIN SMALL LETTER A WITH DIAERESIS
            this.theTable[0x85] = '\u00E0';  // LATIN SMALL LETTER A WITH GRAVE
            this.theTable[0x86] = '\u00E5';  // LATIN SMALL LETTER A WITH RING ABOVE
            this.theTable[0x87] = '\u00E7';  // LATIN SMALL LETTER C WITH CEDILLA
            this.theTable[0x88] = '\u00EA';  // LATIN SMALL LETTER E WITH CIRCUMFLEX
            this.theTable[0x89] = '\u00EB';  // LATIN SMALL LETTER E WITH DIAERESIS
            this.theTable[0x8A] = '\u00E8';  // LATIN SMALL LETTER E WITH GRAVE
            this.theTable[0x8B] = '\u00EF';  // LATIN SMALL LETTER I WITH DIAERESIS
            this.theTable[0x8C] = '\u00EE';  // LATIN SMALL LETTER I WITH CIRCUMFLEX
            this.theTable[0x8D] = '\u00EC';  // LATIN SMALL LETTER I WITH GRAVE
            this.theTable[0x8E] = '\u00C4';  // LATIN CAPITAL LETTER A WITH DIAERESIS
            this.theTable[0x8F] = '\u00C5';  // LATIN CAPITAL LETTER A WITH RING ABOVE
            this.theTable[0x90] = '\u00C9';  // LATIN CAPITAL LETTER E WITH ACUTE
            this.theTable[0x91] = '\u00E6';  // LATIN SMALL LIGATURE AE
            this.theTable[0x92] = '\u00C6';  // LATIN CAPITAL LIGATURE AE
            this.theTable[0x93] = '\u00F4';  // LATIN SMALL LETTER O WITH CIRCUMFLEX
            this.theTable[0x94] = '\u00F6';  // LATIN SMALL LETTER O WITH DIAERESIS
            this.theTable[0x95] = '\u00F2';  // LATIN SMALL LETTER O WITH GRAVE
            this.theTable[0x96] = '\u00FB';  // LATIN SMALL LETTER U WITH CIRCUMFLEX
            this.theTable[0x97] = '\u00F9';  // LATIN SMALL LETTER U WITH GRAVE
            this.theTable[0x98] = '\u00FF';  // LATIN SMALL LETTER Y WITH DIAERESIS
            this.theTable[0x99] = '\u00D6';  // LATIN CAPITAL LETTER O WITH DIAERESIS
            this.theTable[0x9A] = '\u00DC';  // LATIN CAPITAL LETTER U WITH DIAERESIS
            this.theTable[0x9B] = '\u00A2';  // CENT SIGN
            this.theTable[0x9C] = '\u00A3';  // POUND SIGN
            this.theTable[0x9D] = '\u00A5';  // YEN SIGN
            this.theTable[0x9E] = '\u20A7';  // PESETA SIGN
            this.theTable[0x9F] = '\u0192';  // LATIN SMALL LETTER F WITH HOOK
            this.theTable[0xA0] = '\u00E1';  // LATIN SMALL LETTER A WITH ACUTE
            this.theTable[0xA1] = '\u00ED';  // LATIN SMALL LETTER I WITH ACUTE
            this.theTable[0xA2] = '\u00F3';  // LATIN SMALL LETTER O WITH ACUTE
            this.theTable[0xA3] = '\u00FA';  // LATIN SMALL LETTER U WITH ACUTE
            this.theTable[0xA4] = '\u00F1';  // LATIN SMALL LETTER N WITH TILDE
            this.theTable[0xA5] = '\u00D1';  // LATIN CAPITAL LETTER N WITH TILDE
            this.theTable[0xA6] = '\u00AA';  // FEMININE ORDINAL INDICATOR
            this.theTable[0xA7] = '\u00BA';  // MASCULINE ORDINAL INDICATOR
            this.theTable[0xA8] = '\u00BF';  // INVERTED QUESTION MARK
            this.theTable[0xA9] = '\u2310';  // REVERSED NOT SIGN
            this.theTable[0xAA] = '\u00AC';  // NOT SIGN
            this.theTable[0xAB] = '\u00BD';  // VULGAR FRACTION ONE HALF
            this.theTable[0xAC] = '\u00BC';  // VULGAR FRACTION ONE QUARTER
            this.theTable[0xAD] = '\u00A1';  // INVERTED EXCLAMATION MARK
            this.theTable[0xAE] = '\u00AB';  // LEFT-POINTING DOUBLE ANGLE QUOTATION MARK
            this.theTable[0xAF] = '\u00BB';  // RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK
            this.theTable[0xB0] = '\u2591';  // LIGHT SHADE
            this.theTable[0xB1] = '\u2592';  // MEDIUM SHADE
            this.theTable[0xB2] = '\u2593';  // DARK SHADE
            this.theTable[0xB3] = '\u2502';  // BOX DRAWINGS LIGHT VERTICAL
            this.theTable[0xB4] = '\u2524';  // BOX DRAWINGS LIGHT VERTICAL AND LEFT
            this.theTable[0xB5] = '\u2561';  // BOX DRAWINGS VERTICAL SINGLE AND LEFT DOUBLE
            this.theTable[0xB6] = '\u2562';  // BOX DRAWINGS VERTICAL DOUBLE AND LEFT SINGLE
            this.theTable[0xB7] = '\u2556';  // BOX DRAWINGS DOWN DOUBLE AND LEFT SINGLE
            this.theTable[0xB8] = '\u2555';  // BOX DRAWINGS DOWN SINGLE AND LEFT DOUBLE
            this.theTable[0xB9] = '\u2563';  // BOX DRAWINGS DOUBLE VERTICAL AND LEFT
            this.theTable[0xBA] = '\u2551';  // BOX DRAWINGS DOUBLE VERTICAL
            this.theTable[0xBB] = '\u2557';  // BOX DRAWINGS DOUBLE DOWN AND LEFT
            this.theTable[0xBC] = '\u255D';  // BOX DRAWINGS DOUBLE UP AND LEFT
            this.theTable[0xBD] = '\u255C';  // BOX DRAWINGS UP DOUBLE AND LEFT SINGLE
            this.theTable[0xBE] = '\u255B';  // BOX DRAWINGS UP SINGLE AND LEFT DOUBLE
            this.theTable[0xBF] = '\u2510';  // BOX DRAWINGS LIGHT DOWN AND LEFT
            this.theTable[0xC0] = '\u2514';  // BOX DRAWINGS LIGHT UP AND RIGHT
            this.theTable[0xC1] = '\u2534';  // BOX DRAWINGS LIGHT UP AND HORIZONTAL
            this.theTable[0xC2] = '\u252C';  // BOX DRAWINGS LIGHT DOWN AND HORIZONTAL
            this.theTable[0xC3] = '\u251C';  // BOX DRAWINGS LIGHT VERTICAL AND RIGHT
            this.theTable[0xC4] = '\u2500';  // BOX DRAWINGS LIGHT HORIZONTAL
            this.theTable[0xC5] = '\u253C';  // BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL
            this.theTable[0xC6] = '\u255E';  // BOX DRAWINGS VERTICAL SINGLE AND RIGHT DOUBLE
            this.theTable[0xC7] = '\u255F';  // BOX DRAWINGS VERTICAL DOUBLE AND RIGHT SINGLE
            this.theTable[0xC8] = '\u255A';  // BOX DRAWINGS DOUBLE UP AND RIGHT
            this.theTable[0xC9] = '\u2554';  // BOX DRAWINGS DOUBLE DOWN AND RIGHT
            this.theTable[0xCA] = '\u2569';  // BOX DRAWINGS DOUBLE UP AND HORIZONTAL
            this.theTable[0xCB] = '\u2566';  // BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL
            this.theTable[0xCC] = '\u2560';  // BOX DRAWINGS DOUBLE VERTICAL AND RIGHT
            this.theTable[0xCD] = '\u2550';  // BOX DRAWINGS DOUBLE HORIZONTAL
            this.theTable[0xCE] = '\u256C';  // BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL
            this.theTable[0xCF] = '\u2567';  // BOX DRAWINGS UP SINGLE AND HORIZONTAL DOUBLE
            this.theTable[0xD0] = '\u2568';  // BOX DRAWINGS UP DOUBLE AND HORIZONTAL SINGLE
            this.theTable[0xD1] = '\u2564';  // BOX DRAWINGS DOWN SINGLE AND HORIZONTAL DOUBLE
            this.theTable[0xD2] = '\u2565';  // BOX DRAWINGS DOWN DOUBLE AND HORIZONTAL SINGLE
            this.theTable[0xD3] = '\u2559';  // BOX DRAWINGS UP DOUBLE AND RIGHT SINGLE
            this.theTable[0xD4] = '\u2558';  // BOX DRAWINGS UP SINGLE AND RIGHT DOUBLE
            this.theTable[0xD5] = '\u2552';  // BOX DRAWINGS DOWN SINGLE AND RIGHT DOUBLE
            this.theTable[0xD6] = '\u2553';  // BOX DRAWINGS DOWN DOUBLE AND RIGHT SINGLE
            this.theTable[0xD7] = '\u256B';  // BOX DRAWINGS VERTICAL DOUBLE AND HORIZONTAL SINGLE
            this.theTable[0xD8] = '\u256A';  // BOX DRAWINGS VERTICAL SINGLE AND HORIZONTAL DOUBLE
            this.theTable[0xD9] = '\u2518';  // BOX DRAWINGS LIGHT UP AND LEFT
            this.theTable[0xDA] = '\u250C';  // BOX DRAWINGS LIGHT DOWN AND RIGHT
            this.theTable[0xDB] = '\u2588';  // FULL BLOCK
            this.theTable[0xDC] = '\u2584';  // LOWER HALF BLOCK
            this.theTable[0xDD] = '\u258C';  // LEFT HALF BLOCK
            this.theTable[0xDE] = '\u2590';  // RIGHT HALF BLOCK
            this.theTable[0xDF] = '\u2580';  // UPPER HALF BLOCK
            this.theTable[0xE0] = '\u03B1';  // GREEK SMALL LETTER ALPHA
            this.theTable[0xE1] = '\u00DF';  // LATIN SMALL LETTER SHARP S
            this.theTable[0xE2] = '\u0393';  // GREEK CAPITAL LETTER GAMMA
            this.theTable[0xE3] = '\u03C0';  // GREEK SMALL LETTER PI
            this.theTable[0xE4] = '\u03A3';  // GREEK CAPITAL LETTER SIGMA
            this.theTable[0xE5] = '\u03C3';  // GREEK SMALL LETTER SIGMA
            this.theTable[0xE6] = '\u00B5';  // MICRO SIGN
            this.theTable[0xE7] = '\u03C4';  // GREEK SMALL LETTER TAU
            this.theTable[0xE8] = '\u03A6';  // GREEK CAPITAL LETTER PHI
            this.theTable[0xE9] = '\u0398';  // GREEK CAPITAL LETTER THETA
            this.theTable[0xEA] = '\u03A9';  // GREEK CAPITAL LETTER OMEGA
            this.theTable[0xEB] = '\u03B4';  // GREEK SMALL LETTER DELTA
            this.theTable[0xEC] = '\u221E';  // INFINITY
            this.theTable[0xED] = '\u03C6';  // GREEK SMALL LETTER PHI
            this.theTable[0xEE] = '\u03B5';  // GREEK SMALL LETTER EPSILON
            this.theTable[0xEF] = '\u2229';  // INTERSECTION
            this.theTable[0xF0] = '\u2261';  // IDENTICAL TO
            this.theTable[0xF1] = '\u00B1';  // PLUS-MINUS SIGN
            this.theTable[0xF2] = '\u2265';  // GREATER-THAN OR EQUAL TO
            this.theTable[0xF3] = '\u2264';  // LESS-THAN OR EQUAL TO
            this.theTable[0xF4] = '\u2320';  // TOP HALF INTEGRAL
            this.theTable[0xF5] = '\u2321';  // BOTTOM HALF INTEGRAL
            this.theTable[0xF6] = '\u00F7';  // DIVISION SIGN
            this.theTable[0xF7] = '\u2248';  // ALMOST EQUAL TO
            this.theTable[0xF8] = '\u00B0';  // DEGREE SIGN
            this.theTable[0xF9] = '\u2219';  // BULLET OPERATOR
            this.theTable[0xFA] = '\u00B7';  // MIDDLE DOT
            this.theTable[0xFB] = '\u221A';  // SQUARE ROOT
            this.theTable[0xFC] = '\u207F';  // SUPERSCRIPT LATIN SMALL LETTER N
            this.theTable[0xFD] = '\u00B2';  // SUPERSCRIPT TWO
            this.theTable[0xFE] = '\u25A0';  // BLACK SQUARE
            this.theTable[0xFF] = '\u00A0';  // NO-BREAK SPACE

            #endregion // Create character mapping table.
        }
    }

    [Serializable]
    public class ASCIIDOSLatin1 : plexdata.CodePage.ASCIICodePageBase
    {
        public ASCIIDOSLatin1()
            : base(850, "ASCII DOS Latin 1 (CP850)")
        {
        }

        protected override void InitCharacterTable()
        {
            // See also: http://de.wikipedia.org/wiki/Codepage_850
            // ftp://ftp.unicode.org/Public/MAPPINGS/VENDORS/MICSFT/PC/CP850.TXT

            #region Create character mapping table.

            this.theTable = new char[256];

            this.theTable[0x00] = '\u0000';  // NULL
            this.theTable[0x01] = '\u263A';  // START OF HEADING
            this.theTable[0x02] = '\u263B';  // START OF TEXT
            this.theTable[0x03] = '\u2665';  // END OF TEXT
            this.theTable[0x04] = '\u2666';  // END OF TRANSMISSION
            this.theTable[0x05] = '\u2663';  // ENQUIRY
            this.theTable[0x06] = '\u2660';  // ACKNOWLEDGE
            this.theTable[0x07] = '\u2022';  // BELL
            this.theTable[0x08] = '\u25D8';  // BACKSPACE
            this.theTable[0x09] = '\u25CB';  // HORIZONTAL TABULATION
            this.theTable[0x0A] = '\u25D9';  // LINE FEED
            this.theTable[0x0B] = '\u2642';  // VERTICAL TABULATION
            this.theTable[0x0C] = '\u2640';  // FORM FEED
            this.theTable[0x0D] = '\u266A';  // CARRIAGE RETURN
            this.theTable[0x0E] = '\u266B';  // SHIFT OUT
            this.theTable[0x0F] = '\u263C';  // SHIFT IN
            this.theTable[0x10] = '\u25BA';  // DATA LINK ESCAPE
            this.theTable[0x11] = '\u25C4';  // DEVICE CONTROL ONE
            this.theTable[0x12] = '\u2195';  // DEVICE CONTROL TWO
            this.theTable[0x13] = '\u203C';  // DEVICE CONTROL THREE
            this.theTable[0x14] = '\u00B6';  // DEVICE CONTROL FOUR
            this.theTable[0x15] = '\u00A7';  // NEGATIVE ACKNOWLEDGE
            this.theTable[0x16] = '\u25AC';  // SYNCHRONOUS IDLE
            this.theTable[0x17] = '\u21A8';  // END OF TRANSMISSION BLOCK
            this.theTable[0x18] = '\u2191';  // CANCEL
            this.theTable[0x19] = '\u2193';  // END OF MEDIUM
            this.theTable[0x1A] = '\u2192';  // SUBSTITUTE
            this.theTable[0x1B] = '\u2190';  // ESCAPE
            this.theTable[0x1C] = '\u221F';  // FILE SEPARATOR
            this.theTable[0x1D] = '\u2194';  // GROUP SEPARATOR
            this.theTable[0x1E] = '\u25B2';  // RECORD SEPARATOR
            this.theTable[0x1F] = '\u25BC';  // UNIT SEPARATOR
            this.theTable[0x20] = '\u0020';  // SPACE
            this.theTable[0x21] = '\u0021';  // EXCLAMATION MARK
            this.theTable[0x22] = '\u0022';  // QUOTATION MARK
            this.theTable[0x23] = '\u0023';  // NUMBER SIGN
            this.theTable[0x24] = '\u0024';  // DOLLAR SIGN
            this.theTable[0x25] = '\u0025';  // PERCENT SIGN
            this.theTable[0x26] = '\u0026';  // AMPERSAND
            this.theTable[0x27] = '\u0027';  // APOSTROPHE
            this.theTable[0x28] = '\u0028';  // LEFT PARENTHESIS
            this.theTable[0x29] = '\u0029';  // RIGHT PARENTHESIS
            this.theTable[0x2A] = '\u002A';  // ASTERISK
            this.theTable[0x2B] = '\u002B';  // PLUS SIGN
            this.theTable[0x2C] = '\u002C';  // COMMA
            this.theTable[0x2D] = '\u002D';  // HYPHEN-MINUS
            this.theTable[0x2E] = '\u002E';  // FULL STOP
            this.theTable[0x2F] = '\u002F';  // SOLIDUS
            this.theTable[0x30] = '\u0030';  // DIGIT ZERO
            this.theTable[0x31] = '\u0031';  // DIGIT ONE
            this.theTable[0x32] = '\u0032';  // DIGIT TWO
            this.theTable[0x33] = '\u0033';  // DIGIT THREE
            this.theTable[0x34] = '\u0034';  // DIGIT FOUR
            this.theTable[0x35] = '\u0035';  // DIGIT FIVE
            this.theTable[0x36] = '\u0036';  // DIGIT SIX
            this.theTable[0x37] = '\u0037';  // DIGIT SEVEN
            this.theTable[0x38] = '\u0038';  // DIGIT EIGHT
            this.theTable[0x39] = '\u0039';  // DIGIT NINE
            this.theTable[0x3A] = '\u003A';  // COLON
            this.theTable[0x3B] = '\u003B';  // SEMICOLON
            this.theTable[0x3C] = '\u003C';  // LESS-THAN SIGN
            this.theTable[0x3D] = '\u003D';  // EQUALS SIGN
            this.theTable[0x3E] = '\u003E';  // GREATER-THAN SIGN
            this.theTable[0x3F] = '\u003F';  // QUESTION MARK
            this.theTable[0x40] = '\u0040';  // COMMERCIAL AT
            this.theTable[0x41] = '\u0041';  // LATIN CAPITAL LETTER A
            this.theTable[0x42] = '\u0042';  // LATIN CAPITAL LETTER B
            this.theTable[0x43] = '\u0043';  // LATIN CAPITAL LETTER C
            this.theTable[0x44] = '\u0044';  // LATIN CAPITAL LETTER D
            this.theTable[0x45] = '\u0045';  // LATIN CAPITAL LETTER E
            this.theTable[0x46] = '\u0046';  // LATIN CAPITAL LETTER F
            this.theTable[0x47] = '\u0047';  // LATIN CAPITAL LETTER G
            this.theTable[0x48] = '\u0048';  // LATIN CAPITAL LETTER H
            this.theTable[0x49] = '\u0049';  // LATIN CAPITAL LETTER I
            this.theTable[0x4A] = '\u004A';  // LATIN CAPITAL LETTER J
            this.theTable[0x4B] = '\u004B';  // LATIN CAPITAL LETTER K
            this.theTable[0x4C] = '\u004C';  // LATIN CAPITAL LETTER L
            this.theTable[0x4D] = '\u004D';  // LATIN CAPITAL LETTER M
            this.theTable[0x4E] = '\u004E';  // LATIN CAPITAL LETTER N
            this.theTable[0x4F] = '\u004F';  // LATIN CAPITAL LETTER O
            this.theTable[0x50] = '\u0050';  // LATIN CAPITAL LETTER P
            this.theTable[0x51] = '\u0051';  // LATIN CAPITAL LETTER Q
            this.theTable[0x52] = '\u0052';  // LATIN CAPITAL LETTER R
            this.theTable[0x53] = '\u0053';  // LATIN CAPITAL LETTER S
            this.theTable[0x54] = '\u0054';  // LATIN CAPITAL LETTER T
            this.theTable[0x55] = '\u0055';  // LATIN CAPITAL LETTER U
            this.theTable[0x56] = '\u0056';  // LATIN CAPITAL LETTER V
            this.theTable[0x57] = '\u0057';  // LATIN CAPITAL LETTER W
            this.theTable[0x58] = '\u0058';  // LATIN CAPITAL LETTER X
            this.theTable[0x59] = '\u0059';  // LATIN CAPITAL LETTER Y
            this.theTable[0x5A] = '\u005A';  // LATIN CAPITAL LETTER Z
            this.theTable[0x5B] = '\u005B';  // LEFT SQUARE BRACKET
            this.theTable[0x5C] = '\u005C';  // REVERSE SOLIDUS
            this.theTable[0x5D] = '\u005D';  // RIGHT SQUARE BRACKET
            this.theTable[0x5E] = '\u005E';  // CIRCUMFLEX ACCENT
            this.theTable[0x5F] = '\u005F';  // LOW LINE
            this.theTable[0x60] = '\u0060';  // GRAVE ACCENT
            this.theTable[0x61] = '\u0061';  // LATIN SMALL LETTER A
            this.theTable[0x62] = '\u0062';  // LATIN SMALL LETTER B
            this.theTable[0x63] = '\u0063';  // LATIN SMALL LETTER C
            this.theTable[0x64] = '\u0064';  // LATIN SMALL LETTER D
            this.theTable[0x65] = '\u0065';  // LATIN SMALL LETTER E
            this.theTable[0x66] = '\u0066';  // LATIN SMALL LETTER F
            this.theTable[0x67] = '\u0067';  // LATIN SMALL LETTER G
            this.theTable[0x68] = '\u0068';  // LATIN SMALL LETTER H
            this.theTable[0x69] = '\u0069';  // LATIN SMALL LETTER I
            this.theTable[0x6A] = '\u006A';  // LATIN SMALL LETTER J
            this.theTable[0x6B] = '\u006B';  // LATIN SMALL LETTER K
            this.theTable[0x6C] = '\u006C';  // LATIN SMALL LETTER L
            this.theTable[0x6D] = '\u006D';  // LATIN SMALL LETTER M
            this.theTable[0x6E] = '\u006E';  // LATIN SMALL LETTER N
            this.theTable[0x6F] = '\u006F';  // LATIN SMALL LETTER O
            this.theTable[0x70] = '\u0070';  // LATIN SMALL LETTER P
            this.theTable[0x71] = '\u0071';  // LATIN SMALL LETTER Q
            this.theTable[0x72] = '\u0072';  // LATIN SMALL LETTER R
            this.theTable[0x73] = '\u0073';  // LATIN SMALL LETTER S
            this.theTable[0x74] = '\u0074';  // LATIN SMALL LETTER T
            this.theTable[0x75] = '\u0075';  // LATIN SMALL LETTER U
            this.theTable[0x76] = '\u0076';  // LATIN SMALL LETTER V
            this.theTable[0x77] = '\u0077';  // LATIN SMALL LETTER W
            this.theTable[0x78] = '\u0078';  // LATIN SMALL LETTER X
            this.theTable[0x79] = '\u0079';  // LATIN SMALL LETTER Y
            this.theTable[0x7A] = '\u007A';  // LATIN SMALL LETTER Z
            this.theTable[0x7B] = '\u007B';  // LEFT CURLY BRACKET
            this.theTable[0x7C] = '\u007C';  // VERTICAL LINE
            this.theTable[0x7D] = '\u007D';  // RIGHT CURLY BRACKET
            this.theTable[0x7E] = '\u007E';  // TILDE
            this.theTable[0x7F] = '\u2302';  // DELETE
            this.theTable[0x80] = '\u00C7';  // LATIN CAPITAL LETTER C WITH CEDILLA
            this.theTable[0x81] = '\u00FC';  // LATIN SMALL LETTER U WITH DIAERESIS
            this.theTable[0x82] = '\u00E9';  // LATIN SMALL LETTER E WITH ACUTE
            this.theTable[0x83] = '\u00E2';  // LATIN SMALL LETTER A WITH CIRCUMFLEX
            this.theTable[0x84] = '\u00E4';  // LATIN SMALL LETTER A WITH DIAERESIS
            this.theTable[0x85] = '\u00E0';  // LATIN SMALL LETTER A WITH GRAVE
            this.theTable[0x86] = '\u00E5';  // LATIN SMALL LETTER A WITH RING ABOVE
            this.theTable[0x87] = '\u00E7';  // LATIN SMALL LETTER C WITH CEDILLA
            this.theTable[0x88] = '\u00EA';  // LATIN SMALL LETTER E WITH CIRCUMFLEX
            this.theTable[0x89] = '\u00EB';  // LATIN SMALL LETTER E WITH DIAERESIS
            this.theTable[0x8A] = '\u00E8';  // LATIN SMALL LETTER E WITH GRAVE
            this.theTable[0x8B] = '\u00EF';  // LATIN SMALL LETTER I WITH DIAERESIS
            this.theTable[0x8C] = '\u00EE';  // LATIN SMALL LETTER I WITH CIRCUMFLEX
            this.theTable[0x8D] = '\u00EC';  // LATIN SMALL LETTER I WITH GRAVE
            this.theTable[0x8E] = '\u00C4';  // LATIN CAPITAL LETTER A WITH DIAERESIS
            this.theTable[0x8F] = '\u00C5';  // LATIN CAPITAL LETTER A WITH RING ABOVE
            this.theTable[0x90] = '\u00C9';  // LATIN CAPITAL LETTER E WITH ACUTE
            this.theTable[0x91] = '\u00E6';  // LATIN SMALL LIGATURE AE
            this.theTable[0x92] = '\u00C6';  // LATIN CAPITAL LIGATURE AE
            this.theTable[0x93] = '\u00F4';  // LATIN SMALL LETTER O WITH CIRCUMFLEX
            this.theTable[0x94] = '\u00F6';  // LATIN SMALL LETTER O WITH DIAERESIS
            this.theTable[0x95] = '\u00F2';  // LATIN SMALL LETTER O WITH GRAVE
            this.theTable[0x96] = '\u00FB';  // LATIN SMALL LETTER U WITH CIRCUMFLEX
            this.theTable[0x97] = '\u00F9';  // LATIN SMALL LETTER U WITH GRAVE
            this.theTable[0x98] = '\u00FF';  // LATIN SMALL LETTER Y WITH DIAERESIS
            this.theTable[0x99] = '\u00D6';  // LATIN CAPITAL LETTER O WITH DIAERESIS
            this.theTable[0x9A] = '\u00DC';  // LATIN CAPITAL LETTER U WITH DIAERESIS
            this.theTable[0x9B] = '\u00F8';  // LATIN SMALL LETTER O WITH STROKE
            this.theTable[0x9C] = '\u00A3';  // POUND SIGN
            this.theTable[0x9D] = '\u00D8';  // LATIN CAPITAL LETTER O WITH STROKE
            this.theTable[0x9E] = '\u00D7';  // MULTIPLICATION SIGN
            this.theTable[0x9F] = '\u0192';  // LATIN SMALL LETTER F WITH HOOK
            this.theTable[0xA0] = '\u00E1';  // LATIN SMALL LETTER A WITH ACUTE
            this.theTable[0xA1] = '\u00ED';  // LATIN SMALL LETTER I WITH ACUTE
            this.theTable[0xA2] = '\u00F3';  // LATIN SMALL LETTER O WITH ACUTE
            this.theTable[0xA3] = '\u00FA';  // LATIN SMALL LETTER U WITH ACUTE
            this.theTable[0xA4] = '\u00F1';  // LATIN SMALL LETTER N WITH TILDE
            this.theTable[0xA5] = '\u00D1';  // LATIN CAPITAL LETTER N WITH TILDE
            this.theTable[0xA6] = '\u00AA';  // FEMININE ORDINAL INDICATOR
            this.theTable[0xA7] = '\u00BA';  // MASCULINE ORDINAL INDICATOR
            this.theTable[0xA8] = '\u00BF';  // INVERTED QUESTION MARK
            this.theTable[0xA9] = '\u00AE';  // REGISTERED SIGN
            this.theTable[0xAA] = '\u00AC';  // NOT SIGN
            this.theTable[0xAB] = '\u00BD';  // VULGAR FRACTION ONE HALF
            this.theTable[0xAC] = '\u00BC';  // VULGAR FRACTION ONE QUARTER
            this.theTable[0xAD] = '\u00A1';  // INVERTED EXCLAMATION MARK
            this.theTable[0xAE] = '\u00AB';  // LEFT-POINTING DOUBLE ANGLE QUOTATION MARK
            this.theTable[0xAF] = '\u00BB';  // RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK
            this.theTable[0xB0] = '\u2591';  // LIGHT SHADE
            this.theTable[0xB1] = '\u2592';  // MEDIUM SHADE
            this.theTable[0xB2] = '\u2593';  // DARK SHADE
            this.theTable[0xB3] = '\u2502';  // BOX DRAWINGS LIGHT VERTICAL
            this.theTable[0xB4] = '\u2524';  // BOX DRAWINGS LIGHT VERTICAL AND LEFT
            this.theTable[0xB5] = '\u00C1';  // LATIN CAPITAL LETTER A WITH ACUTE
            this.theTable[0xB6] = '\u00C2';  // LATIN CAPITAL LETTER A WITH CIRCUMFLEX
            this.theTable[0xB7] = '\u00C0';  // LATIN CAPITAL LETTER A WITH GRAVE
            this.theTable[0xB8] = '\u00A9';  // COPYRIGHT SIGN
            this.theTable[0xB9] = '\u2563';  // BOX DRAWINGS DOUBLE VERTICAL AND LEFT
            this.theTable[0xBA] = '\u2551';  // BOX DRAWINGS DOUBLE VERTICAL
            this.theTable[0xBB] = '\u2557';  // BOX DRAWINGS DOUBLE DOWN AND LEFT
            this.theTable[0xBC] = '\u255D';  // BOX DRAWINGS DOUBLE UP AND LEFT
            this.theTable[0xBD] = '\u00A2';  // CENT SIGN
            this.theTable[0xBE] = '\u00A5';  // YEN SIGN
            this.theTable[0xBF] = '\u2510';  // BOX DRAWINGS LIGHT DOWN AND LEFT
            this.theTable[0xC0] = '\u2514';  // BOX DRAWINGS LIGHT UP AND RIGHT
            this.theTable[0xC1] = '\u2534';  // BOX DRAWINGS LIGHT UP AND HORIZONTAL
            this.theTable[0xC2] = '\u252C';  // BOX DRAWINGS LIGHT DOWN AND HORIZONTAL
            this.theTable[0xC3] = '\u251C';  // BOX DRAWINGS LIGHT VERTICAL AND RIGHT
            this.theTable[0xC4] = '\u2500';  // BOX DRAWINGS LIGHT HORIZONTAL
            this.theTable[0xC5] = '\u253C';  // BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL
            this.theTable[0xC6] = '\u00E3';  // LATIN SMALL LETTER A WITH TILDE
            this.theTable[0xC7] = '\u00C3';  // LATIN CAPITAL LETTER A WITH TILDE
            this.theTable[0xC8] = '\u255A';  // BOX DRAWINGS DOUBLE UP AND RIGHT
            this.theTable[0xC9] = '\u2554';  // BOX DRAWINGS DOUBLE DOWN AND RIGHT
            this.theTable[0xCA] = '\u2569';  // BOX DRAWINGS DOUBLE UP AND HORIZONTAL
            this.theTable[0xCB] = '\u2566';  // BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL
            this.theTable[0xCC] = '\u2560';  // BOX DRAWINGS DOUBLE VERTICAL AND RIGHT
            this.theTable[0xCD] = '\u2550';  // BOX DRAWINGS DOUBLE HORIZONTAL
            this.theTable[0xCE] = '\u256C';  // BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL
            this.theTable[0xCF] = '\u00A4';  // CURRENCY SIGN
            this.theTable[0xD0] = '\u00F0';  // LATIN SMALL LETTER ETH
            this.theTable[0xD1] = '\u00D0';  // LATIN CAPITAL LETTER ETH
            this.theTable[0xD2] = '\u00CA';  // LATIN CAPITAL LETTER E WITH CIRCUMFLEX
            this.theTable[0xD3] = '\u00CB';  // LATIN CAPITAL LETTER E WITH DIAERESIS
            this.theTable[0xD4] = '\u00C8';  // LATIN CAPITAL LETTER E WITH GRAVE
            this.theTable[0xD5] = '\u0131';  // LATIN SMALL LETTER DOTLESS I
            this.theTable[0xD6] = '\u00CD';  // LATIN CAPITAL LETTER I WITH ACUTE
            this.theTable[0xD7] = '\u00CE';  // LATIN CAPITAL LETTER I WITH CIRCUMFLEX
            this.theTable[0xD8] = '\u00CF';  // LATIN CAPITAL LETTER I WITH DIAERESIS
            this.theTable[0xD9] = '\u2518';  // BOX DRAWINGS LIGHT UP AND LEFT
            this.theTable[0xDA] = '\u250C';  // BOX DRAWINGS LIGHT DOWN AND RIGHT
            this.theTable[0xDB] = '\u2588';  // FULL BLOCK
            this.theTable[0xDC] = '\u2584';  // LOWER HALF BLOCK
            this.theTable[0xDD] = '\u00A6';  // BROKEN BAR
            this.theTable[0xDE] = '\u00CC';  // LATIN CAPITAL LETTER I WITH GRAVE
            this.theTable[0xDF] = '\u2580';  // UPPER HALF BLOCK
            this.theTable[0xE0] = '\u00D3';  // LATIN CAPITAL LETTER O WITH ACUTE
            this.theTable[0xE1] = '\u00DF';  // LATIN SMALL LETTER SHARP S
            this.theTable[0xE2] = '\u00D4';  // LATIN CAPITAL LETTER O WITH CIRCUMFLEX
            this.theTable[0xE3] = '\u00D2';  // LATIN CAPITAL LETTER O WITH GRAVE
            this.theTable[0xE4] = '\u00F5';  // LATIN SMALL LETTER O WITH TILDE
            this.theTable[0xE5] = '\u00D5';  // LATIN CAPITAL LETTER O WITH TILDE
            this.theTable[0xE6] = '\u00B5';  // MICRO SIGN
            this.theTable[0xE7] = '\u00FE';  // LATIN SMALL LETTER THORN
            this.theTable[0xE8] = '\u00DE';  // LATIN CAPITAL LETTER THORN
            this.theTable[0xE9] = '\u00DA';  // LATIN CAPITAL LETTER U WITH ACUTE
            this.theTable[0xEA] = '\u00DB';  // LATIN CAPITAL LETTER U WITH CIRCUMFLEX
            this.theTable[0xEB] = '\u00D9';  // LATIN CAPITAL LETTER U WITH GRAVE
            this.theTable[0xEC] = '\u00FD';  // LATIN SMALL LETTER Y WITH ACUTE
            this.theTable[0xED] = '\u00DD';  // LATIN CAPITAL LETTER Y WITH ACUTE
            this.theTable[0xEE] = '\u00AF';  // MACRON
            this.theTable[0xEF] = '\u00B4';  // ACUTE ACCENT
            this.theTable[0xF0] = '\u00AD';  // SOFT HYPHEN
            this.theTable[0xF1] = '\u00B1';  // PLUS-MINUS SIGN
            this.theTable[0xF2] = '\u2017';  // DOUBLE LOW LINE
            this.theTable[0xF3] = '\u00BE';  // VULGAR FRACTION THREE QUARTERS
            this.theTable[0xF4] = '\u00B6';  // PILCROW SIGN
            this.theTable[0xF5] = '\u00A7';  // SECTION SIGN
            this.theTable[0xF6] = '\u00F7';  // DIVISION SIGN
            this.theTable[0xF7] = '\u00B8';  // CEDILLA
            this.theTable[0xF8] = '\u00B0';  // DEGREE SIGN
            this.theTable[0xF9] = '\u00A8';  // DIAERESIS
            this.theTable[0xFA] = '\u00B7';  // MIDDLE DOT
            this.theTable[0xFB] = '\u00B9';  // SUPERSCRIPT ONE
            this.theTable[0xFC] = '\u00B3';  // SUPERSCRIPT THREE
            this.theTable[0xFD] = '\u00B2';  // SUPERSCRIPT TWO
            this.theTable[0xFE] = '\u25A0';  // BLACK SQUARE
            this.theTable[0xFF] = '\u00A0';  // NO-BREAK SPACE

            #endregion // Create character mapping table.
        }
    }

    [Serializable]
    public class ASCIIDOSLatin2 : plexdata.CodePage.ASCIICodePageBase
    {
        public ASCIIDOSLatin2()
            : base(852, "ASCII DOS Latin 2 (CP852)")
        {
        }

        protected override void InitCharacterTable()
        {
            // See also: http://de.wikipedia.org/wiki/Codepage_852
            // ftp://ftp.unicode.org/Public/MAPPINGS/VENDORS/MICSFT/PC/CP852.TXT

            #region Create character mapping table.

            this.theTable = new char[256];

            this.theTable[0x00] = '\u0000';  // NULL
            this.theTable[0x01] = '\u263A';  // START OF HEADING
            this.theTable[0x02] = '\u263B';  // START OF TEXT
            this.theTable[0x03] = '\u2665';  // END OF TEXT
            this.theTable[0x04] = '\u2666';  // END OF TRANSMISSION
            this.theTable[0x05] = '\u2663';  // ENQUIRY
            this.theTable[0x06] = '\u2660';  // ACKNOWLEDGE
            this.theTable[0x07] = '\u2022';  // BELL
            this.theTable[0x08] = '\u25D8';  // BACKSPACE
            this.theTable[0x09] = '\u25CB';  // HORIZONTAL TABULATION
            this.theTable[0x0A] = '\u25D9';  // LINE FEED
            this.theTable[0x0B] = '\u2642';  // VERTICAL TABULATION
            this.theTable[0x0C] = '\u2640';  // FORM FEED
            this.theTable[0x0D] = '\u266A';  // CARRIAGE RETURN
            this.theTable[0x0E] = '\u266B';  // SHIFT OUT
            this.theTable[0x0F] = '\u263C';  // SHIFT IN
            this.theTable[0x10] = '\u25BA';  // DATA LINK ESCAPE
            this.theTable[0x11] = '\u25C4';  // DEVICE CONTROL ONE
            this.theTable[0x12] = '\u2195';  // DEVICE CONTROL TWO
            this.theTable[0x13] = '\u203C';  // DEVICE CONTROL THREE
            this.theTable[0x14] = '\u00B6';  // DEVICE CONTROL FOUR
            this.theTable[0x15] = '\u00A7';  // NEGATIVE ACKNOWLEDGE
            this.theTable[0x16] = '\u25AC';  // SYNCHRONOUS IDLE
            this.theTable[0x17] = '\u21A8';  // END OF TRANSMISSION BLOCK
            this.theTable[0x18] = '\u2191';  // CANCEL
            this.theTable[0x19] = '\u2193';  // END OF MEDIUM
            this.theTable[0x1A] = '\u2192';  // SUBSTITUTE
            this.theTable[0x1B] = '\u2190';  // ESCAPE
            this.theTable[0x1C] = '\u221F';  // FILE SEPARATOR
            this.theTable[0x1D] = '\u2194';  // GROUP SEPARATOR
            this.theTable[0x1E] = '\u25B2';  // RECORD SEPARATOR
            this.theTable[0x1F] = '\u25BC';  // UNIT SEPARATOR
            this.theTable[0x20] = '\u0020';  // SPACE
            this.theTable[0x21] = '\u0021';  // EXCLAMATION MARK
            this.theTable[0x22] = '\u0022';  // QUOTATION MARK
            this.theTable[0x23] = '\u0023';  // NUMBER SIGN
            this.theTable[0x24] = '\u0024';  // DOLLAR SIGN
            this.theTable[0x25] = '\u0025';  // PERCENT SIGN
            this.theTable[0x26] = '\u0026';  // AMPERSAND
            this.theTable[0x27] = '\u0027';  // APOSTROPHE
            this.theTable[0x28] = '\u0028';  // LEFT PARENTHESIS
            this.theTable[0x29] = '\u0029';  // RIGHT PARENTHESIS
            this.theTable[0x2A] = '\u002A';  // ASTERISK
            this.theTable[0x2B] = '\u002B';  // PLUS SIGN
            this.theTable[0x2C] = '\u002C';  // COMMA
            this.theTable[0x2D] = '\u002D';  // HYPHEN-MINUS
            this.theTable[0x2E] = '\u002E';  // FULL STOP
            this.theTable[0x2F] = '\u002F';  // SOLIDUS
            this.theTable[0x30] = '\u0030';  // DIGIT ZERO
            this.theTable[0x31] = '\u0031';  // DIGIT ONE
            this.theTable[0x32] = '\u0032';  // DIGIT TWO
            this.theTable[0x33] = '\u0033';  // DIGIT THREE
            this.theTable[0x34] = '\u0034';  // DIGIT FOUR
            this.theTable[0x35] = '\u0035';  // DIGIT FIVE
            this.theTable[0x36] = '\u0036';  // DIGIT SIX
            this.theTable[0x37] = '\u0037';  // DIGIT SEVEN
            this.theTable[0x38] = '\u0038';  // DIGIT EIGHT
            this.theTable[0x39] = '\u0039';  // DIGIT NINE
            this.theTable[0x3A] = '\u003A';  // COLON
            this.theTable[0x3B] = '\u003B';  // SEMICOLON
            this.theTable[0x3C] = '\u003C';  // LESS-THAN SIGN
            this.theTable[0x3D] = '\u003D';  // EQUALS SIGN
            this.theTable[0x3E] = '\u003E';  // GREATER-THAN SIGN
            this.theTable[0x3F] = '\u003F';  // QUESTION MARK
            this.theTable[0x40] = '\u0040';  // COMMERCIAL AT
            this.theTable[0x41] = '\u0041';  // LATIN CAPITAL LETTER A
            this.theTable[0x42] = '\u0042';  // LATIN CAPITAL LETTER B
            this.theTable[0x43] = '\u0043';  // LATIN CAPITAL LETTER C
            this.theTable[0x44] = '\u0044';  // LATIN CAPITAL LETTER D
            this.theTable[0x45] = '\u0045';  // LATIN CAPITAL LETTER E
            this.theTable[0x46] = '\u0046';  // LATIN CAPITAL LETTER F
            this.theTable[0x47] = '\u0047';  // LATIN CAPITAL LETTER G
            this.theTable[0x48] = '\u0048';  // LATIN CAPITAL LETTER H
            this.theTable[0x49] = '\u0049';  // LATIN CAPITAL LETTER I
            this.theTable[0x4A] = '\u004A';  // LATIN CAPITAL LETTER J
            this.theTable[0x4B] = '\u004B';  // LATIN CAPITAL LETTER K
            this.theTable[0x4C] = '\u004C';  // LATIN CAPITAL LETTER L
            this.theTable[0x4D] = '\u004D';  // LATIN CAPITAL LETTER M
            this.theTable[0x4E] = '\u004E';  // LATIN CAPITAL LETTER N
            this.theTable[0x4F] = '\u004F';  // LATIN CAPITAL LETTER O
            this.theTable[0x50] = '\u0050';  // LATIN CAPITAL LETTER P
            this.theTable[0x51] = '\u0051';  // LATIN CAPITAL LETTER Q
            this.theTable[0x52] = '\u0052';  // LATIN CAPITAL LETTER R
            this.theTable[0x53] = '\u0053';  // LATIN CAPITAL LETTER S
            this.theTable[0x54] = '\u0054';  // LATIN CAPITAL LETTER T
            this.theTable[0x55] = '\u0055';  // LATIN CAPITAL LETTER U
            this.theTable[0x56] = '\u0056';  // LATIN CAPITAL LETTER V
            this.theTable[0x57] = '\u0057';  // LATIN CAPITAL LETTER W
            this.theTable[0x58] = '\u0058';  // LATIN CAPITAL LETTER X
            this.theTable[0x59] = '\u0059';  // LATIN CAPITAL LETTER Y
            this.theTable[0x5A] = '\u005A';  // LATIN CAPITAL LETTER Z
            this.theTable[0x5B] = '\u005B';  // LEFT SQUARE BRACKET
            this.theTable[0x5C] = '\u005C';  // REVERSE SOLIDUS
            this.theTable[0x5D] = '\u005D';  // RIGHT SQUARE BRACKET
            this.theTable[0x5E] = '\u005E';  // CIRCUMFLEX ACCENT
            this.theTable[0x5F] = '\u005F';  // LOW LINE
            this.theTable[0x60] = '\u0060';  // GRAVE ACCENT
            this.theTable[0x61] = '\u0061';  // LATIN SMALL LETTER A
            this.theTable[0x62] = '\u0062';  // LATIN SMALL LETTER B
            this.theTable[0x63] = '\u0063';  // LATIN SMALL LETTER C
            this.theTable[0x64] = '\u0064';  // LATIN SMALL LETTER D
            this.theTable[0x65] = '\u0065';  // LATIN SMALL LETTER E
            this.theTable[0x66] = '\u0066';  // LATIN SMALL LETTER F
            this.theTable[0x67] = '\u0067';  // LATIN SMALL LETTER G
            this.theTable[0x68] = '\u0068';  // LATIN SMALL LETTER H
            this.theTable[0x69] = '\u0069';  // LATIN SMALL LETTER I
            this.theTable[0x6A] = '\u006A';  // LATIN SMALL LETTER J
            this.theTable[0x6B] = '\u006B';  // LATIN SMALL LETTER K
            this.theTable[0x6C] = '\u006C';  // LATIN SMALL LETTER L
            this.theTable[0x6D] = '\u006D';  // LATIN SMALL LETTER M
            this.theTable[0x6E] = '\u006E';  // LATIN SMALL LETTER N
            this.theTable[0x6F] = '\u006F';  // LATIN SMALL LETTER O
            this.theTable[0x70] = '\u0070';  // LATIN SMALL LETTER P
            this.theTable[0x71] = '\u0071';  // LATIN SMALL LETTER Q
            this.theTable[0x72] = '\u0072';  // LATIN SMALL LETTER R
            this.theTable[0x73] = '\u0073';  // LATIN SMALL LETTER S
            this.theTable[0x74] = '\u0074';  // LATIN SMALL LETTER T
            this.theTable[0x75] = '\u0075';  // LATIN SMALL LETTER U
            this.theTable[0x76] = '\u0076';  // LATIN SMALL LETTER V
            this.theTable[0x77] = '\u0077';  // LATIN SMALL LETTER W
            this.theTable[0x78] = '\u0078';  // LATIN SMALL LETTER X
            this.theTable[0x79] = '\u0079';  // LATIN SMALL LETTER Y
            this.theTable[0x7A] = '\u007A';  // LATIN SMALL LETTER Z
            this.theTable[0x7B] = '\u007B';  // LEFT CURLY BRACKET
            this.theTable[0x7C] = '\u007C';  // VERTICAL LINE
            this.theTable[0x7D] = '\u007D';  // RIGHT CURLY BRACKET
            this.theTable[0x7E] = '\u007E';  // TILDE
            this.theTable[0x7F] = '\u2302';  // DELETE
            this.theTable[0x80] = '\u00C7';  // LATIN CAPITAL LETTER C WITH CEDILLA
            this.theTable[0x81] = '\u00FC';  // LATIN SMALL LETTER U WITH DIAERESIS
            this.theTable[0x82] = '\u00E9';  // LATIN SMALL LETTER E WITH ACUTE
            this.theTable[0x83] = '\u00E2';  // LATIN SMALL LETTER A WITH CIRCUMFLEX
            this.theTable[0x84] = '\u00E4';  // LATIN SMALL LETTER A WITH DIAERESIS
            this.theTable[0x85] = '\u016F';  // LATIN SMALL LETTER U WITH RING ABOVE
            this.theTable[0x86] = '\u0107';  // LATIN SMALL LETTER C WITH ACUTE
            this.theTable[0x87] = '\u00E7';  // LATIN SMALL LETTER C WITH CEDILLA
            this.theTable[0x88] = '\u0142';  // LATIN SMALL LETTER L WITH STROKE
            this.theTable[0x89] = '\u00EB';  // LATIN SMALL LETTER E WITH DIAERESIS
            this.theTable[0x8A] = '\u0150';  // LATIN CAPITAL LETTER O WITH DOUBLE ACUTE
            this.theTable[0x8B] = '\u0151';  // LATIN SMALL LETTER O WITH DOUBLE ACUTE
            this.theTable[0x8C] = '\u00EE';  // LATIN SMALL LETTER I WITH CIRCUMFLEX
            this.theTable[0x8D] = '\u0179';  // LATIN CAPITAL LETTER Z WITH ACUTE
            this.theTable[0x8E] = '\u00C4';  // LATIN CAPITAL LETTER A WITH DIAERESIS
            this.theTable[0x8F] = '\u0106';  // LATIN CAPITAL LETTER C WITH ACUTE
            this.theTable[0x90] = '\u00C9';  // LATIN CAPITAL LETTER E WITH ACUTE
            this.theTable[0x91] = '\u0139';  // LATIN CAPITAL LETTER L WITH ACUTE
            this.theTable[0x92] = '\u013A';  // LATIN SMALL LETTER L WITH ACUTE
            this.theTable[0x93] = '\u00F4';  // LATIN SMALL LETTER O WITH CIRCUMFLEX
            this.theTable[0x94] = '\u00F6';  // LATIN SMALL LETTER O WITH DIAERESIS
            this.theTable[0x95] = '\u013D';  // LATIN CAPITAL LETTER L WITH CARON
            this.theTable[0x96] = '\u013E';  // LATIN SMALL LETTER L WITH CARON
            this.theTable[0x97] = '\u015A';  // LATIN CAPITAL LETTER S WITH ACUTE
            this.theTable[0x98] = '\u015B';  // LATIN SMALL LETTER S WITH ACUTE
            this.theTable[0x99] = '\u00D6';  // LATIN CAPITAL LETTER O WITH DIAERESIS
            this.theTable[0x9A] = '\u00DC';  // LATIN CAPITAL LETTER U WITH DIAERESIS
            this.theTable[0x9B] = '\u0164';  // LATIN CAPITAL LETTER T WITH CARON
            this.theTable[0x9C] = '\u0165';  // LATIN SMALL LETTER T WITH CARON
            this.theTable[0x9D] = '\u0141';  // LATIN CAPITAL LETTER L WITH STROKE
            this.theTable[0x9E] = '\u00D7';  // MULTIPLICATION SIGN
            this.theTable[0x9F] = '\u010D';  // LATIN SMALL LETTER C WITH CARON
            this.theTable[0xA0] = '\u00E1';  // LATIN SMALL LETTER A WITH ACUTE
            this.theTable[0xA1] = '\u00ED';  // LATIN SMALL LETTER I WITH ACUTE
            this.theTable[0xA2] = '\u00F3';  // LATIN SMALL LETTER O WITH ACUTE
            this.theTable[0xA3] = '\u00FA';  // LATIN SMALL LETTER U WITH ACUTE
            this.theTable[0xA4] = '\u0104';  // LATIN CAPITAL LETTER A WITH OGONEK
            this.theTable[0xA5] = '\u0105';  // LATIN SMALL LETTER A WITH OGONEK
            this.theTable[0xA6] = '\u017D';  // LATIN CAPITAL LETTER Z WITH CARON
            this.theTable[0xA7] = '\u017E';  // LATIN SMALL LETTER Z WITH CARON
            this.theTable[0xA8] = '\u0118';  // LATIN CAPITAL LETTER E WITH OGONEK
            this.theTable[0xA9] = '\u0119';  // LATIN SMALL LETTER E WITH OGONEK
            this.theTable[0xAA] = '\u00AC';  // NOT SIGN
            this.theTable[0xAB] = '\u017A';  // LATIN SMALL LETTER Z WITH ACUTE
            this.theTable[0xAC] = '\u010C';  // LATIN CAPITAL LETTER C WITH CARON
            this.theTable[0xAD] = '\u015F';  // LATIN SMALL LETTER S WITH CEDILLA
            this.theTable[0xAE] = '\u00AB';  // LEFT-POINTING DOUBLE ANGLE QUOTATION MARK
            this.theTable[0xAF] = '\u00BB';  // RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK
            this.theTable[0xB0] = '\u2591';  // LIGHT SHADE
            this.theTable[0xB1] = '\u2592';  // MEDIUM SHADE
            this.theTable[0xB2] = '\u2593';  // DARK SHADE
            this.theTable[0xB3] = '\u2502';  // BOX DRAWINGS LIGHT VERTICAL
            this.theTable[0xB4] = '\u2524';  // BOX DRAWINGS LIGHT VERTICAL AND LEFT
            this.theTable[0xB5] = '\u00C1';  // LATIN CAPITAL LETTER A WITH ACUTE
            this.theTable[0xB6] = '\u00C2';  // LATIN CAPITAL LETTER A WITH CIRCUMFLEX
            this.theTable[0xB7] = '\u011A';  // LATIN CAPITAL LETTER E WITH CARON
            this.theTable[0xB8] = '\u015E';  // LATIN CAPITAL LETTER S WITH CEDILLA
            this.theTable[0xB9] = '\u2563';  // BOX DRAWINGS DOUBLE VERTICAL AND LEFT
            this.theTable[0xBA] = '\u2551';  // BOX DRAWINGS DOUBLE VERTICAL
            this.theTable[0xBB] = '\u2557';  // BOX DRAWINGS DOUBLE DOWN AND LEFT
            this.theTable[0xBC] = '\u255D';  // BOX DRAWINGS DOUBLE UP AND LEFT
            this.theTable[0xBD] = '\u017B';  // LATIN CAPITAL LETTER Z WITH DOT ABOVE
            this.theTable[0xBE] = '\u017C';  // LATIN SMALL LETTER Z WITH DOT ABOVE
            this.theTable[0xBF] = '\u2510';  // BOX DRAWINGS LIGHT DOWN AND LEFT
            this.theTable[0xC0] = '\u2514';  // BOX DRAWINGS LIGHT UP AND RIGHT
            this.theTable[0xC1] = '\u2534';  // BOX DRAWINGS LIGHT UP AND HORIZONTAL
            this.theTable[0xC2] = '\u252C';  // BOX DRAWINGS LIGHT DOWN AND HORIZONTAL
            this.theTable[0xC3] = '\u251C';  // BOX DRAWINGS LIGHT VERTICAL AND RIGHT
            this.theTable[0xC4] = '\u2500';  // BOX DRAWINGS LIGHT HORIZONTAL
            this.theTable[0xC5] = '\u253C';  // BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL
            this.theTable[0xC6] = '\u0102';  // LATIN CAPITAL LETTER A WITH BREVE
            this.theTable[0xC7] = '\u0103';  // LATIN SMALL LETTER A WITH BREVE
            this.theTable[0xC8] = '\u255A';  // BOX DRAWINGS DOUBLE UP AND RIGHT
            this.theTable[0xC9] = '\u2554';  // BOX DRAWINGS DOUBLE DOWN AND RIGHT
            this.theTable[0xCA] = '\u2569';  // BOX DRAWINGS DOUBLE UP AND HORIZONTAL
            this.theTable[0xCB] = '\u2566';  // BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL
            this.theTable[0xCC] = '\u2560';  // BOX DRAWINGS DOUBLE VERTICAL AND RIGHT
            this.theTable[0xCD] = '\u2550';  // BOX DRAWINGS DOUBLE HORIZONTAL
            this.theTable[0xCE] = '\u256C';  // BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL
            this.theTable[0xCF] = '\u00A4';  // CURRENCY SIGN
            this.theTable[0xD0] = '\u0111';  // LATIN SMALL LETTER D WITH STROKE
            this.theTable[0xD1] = '\u0110';  // LATIN CAPITAL LETTER D WITH STROKE
            this.theTable[0xD2] = '\u010E';  // LATIN CAPITAL LETTER D WITH CARON
            this.theTable[0xD3] = '\u00CB';  // LATIN CAPITAL LETTER E WITH DIAERESIS
            this.theTable[0xD4] = '\u010F';  // LATIN SMALL LETTER D WITH CARON
            this.theTable[0xD5] = '\u0147';  // LATIN CAPITAL LETTER N WITH CARON
            this.theTable[0xD6] = '\u00CD';  // LATIN CAPITAL LETTER I WITH ACUTE
            this.theTable[0xD7] = '\u00CE';  // LATIN CAPITAL LETTER I WITH CIRCUMFLEX
            this.theTable[0xD8] = '\u011B';  // LATIN SMALL LETTER E WITH CARON
            this.theTable[0xD9] = '\u2518';  // BOX DRAWINGS LIGHT UP AND LEFT
            this.theTable[0xDA] = '\u250C';  // BOX DRAWINGS LIGHT DOWN AND RIGHT
            this.theTable[0xDB] = '\u2588';  // FULL BLOCK
            this.theTable[0xDC] = '\u2584';  // LOWER HALF BLOCK
            this.theTable[0xDD] = '\u0162';  // LATIN CAPITAL LETTER T WITH CEDILLA
            this.theTable[0xDE] = '\u016E';  // LATIN CAPITAL LETTER U WITH RING ABOVE
            this.theTable[0xDF] = '\u2580';  // UPPER HALF BLOCK
            this.theTable[0xE0] = '\u00D3';  // LATIN CAPITAL LETTER O WITH ACUTE
            this.theTable[0xE1] = '\u00DF';  // LATIN SMALL LETTER SHARP S
            this.theTable[0xE2] = '\u00D4';  // LATIN CAPITAL LETTER O WITH CIRCUMFLEX
            this.theTable[0xE3] = '\u0143';  // LATIN CAPITAL LETTER N WITH ACUTE
            this.theTable[0xE4] = '\u0144';  // LATIN SMALL LETTER N WITH ACUTE
            this.theTable[0xE5] = '\u0148';  // LATIN SMALL LETTER N WITH CARON
            this.theTable[0xE6] = '\u0160';  // LATIN CAPITAL LETTER S WITH CARON
            this.theTable[0xE7] = '\u0161';  // LATIN SMALL LETTER S WITH CARON
            this.theTable[0xE8] = '\u0154';  // LATIN CAPITAL LETTER R WITH ACUTE
            this.theTable[0xE9] = '\u00DA';  // LATIN CAPITAL LETTER U WITH ACUTE
            this.theTable[0xEA] = '\u0155';  // LATIN SMALL LETTER R WITH ACUTE
            this.theTable[0xEB] = '\u0170';  // LATIN CAPITAL LETTER U WITH DOUBLE ACUTE
            this.theTable[0xEC] = '\u00FD';  // LATIN SMALL LETTER Y WITH ACUTE
            this.theTable[0xED] = '\u00DD';  // LATIN CAPITAL LETTER Y WITH ACUTE
            this.theTable[0xEE] = '\u0163';  // LATIN SMALL LETTER T WITH CEDILLA
            this.theTable[0xEF] = '\u00B4';  // ACUTE ACCENT
            this.theTable[0xF0] = '\u00AD';  // SOFT HYPHEN
            this.theTable[0xF1] = '\u02DD';  // DOUBLE ACUTE ACCENT
            this.theTable[0xF2] = '\u02DB';  // OGONEK
            this.theTable[0xF3] = '\u02C7';  // CARON
            this.theTable[0xF4] = '\u02D8';  // BREVE
            this.theTable[0xF5] = '\u00A7';  // SECTION SIGN
            this.theTable[0xF6] = '\u00F7';  // DIVISION SIGN
            this.theTable[0xF7] = '\u00B8';  // CEDILLA
            this.theTable[0xF8] = '\u00B0';  // DEGREE SIGN
            this.theTable[0xF9] = '\u00A8';  // DIAERESIS
            this.theTable[0xFA] = '\u02D9';  // DOT ABOVE
            this.theTable[0xFB] = '\u0171';  // LATIN SMALL LETTER U WITH DOUBLE ACUTE
            this.theTable[0xFC] = '\u0158';  // LATIN CAPITAL LETTER R WITH CARON
            this.theTable[0xFD] = '\u0159';  // LATIN SMALL LETTER R WITH CARON
            this.theTable[0xFE] = '\u25A0';  // BLACK SQUARE
            this.theTable[0xFF] = '\u00A0';  // NO-BREAK SPACE

            #endregion // Create character mapping table.
        }
    }

    [Serializable]
    public abstract class ASCIICodePageBase : System.Text.Encoding
    {
        private string encodingName = "";

        protected char[] theTable = null;

        private ASCIICodePageBase()
            : base()
        {
            System.Diagnostics.Debug.Assert(false, "Not supported");
        }

        protected ASCIICodePageBase(int codePage)
            : base(codePage)
        {
            this.encodingName = base.EncodingName;
            this.InitCharacterTable();
        }

        protected ASCIICodePageBase(int codePage, string encodingName)
            : base(codePage)
        {
            this.encodingName = encodingName;
            this.InitCharacterTable();
        }

        protected abstract void InitCharacterTable();

        public override string EncodingName
        {
            get { return this.encodingName; }
        }

        public override bool IsSingleByte
        {
            get { return true; }
        }

        public override int GetByteCount(char[] chars, int index, int count)
        {
            #region Parameter validation.

            if (chars == null)
            {
                throw new ArgumentNullException("chars", "Parameter is null or empty.");
            }

            if (index < 0)
            {
                throw new ArgumentOutOfRangeException("index", "Parameter must be grater than or equal to zero.");
            }

            if (count < 0)
            {
                throw new ArgumentOutOfRangeException("count", "Parameter must be grater than or equal to zero.");
            }

            if (index > this.theTable.Length || (index + count) > this.theTable.Length)
            {
                throw new ArgumentOutOfRangeException("index, count", "Index and/or count do not denote a valid range in chars.");
            }

            #endregion // Parameter validation.

            return count - index;
        }

        public override int GetBytes(char[] chars, int charIndex, int charCount, byte[] bytes, int byteIndex)
        {
            #region Parameter validation.

            if (chars == null)
            {
                throw new ArgumentNullException("chars", "Parameter is null or empty.");
            }

            if (bytes == null)
            {
                throw new ArgumentNullException("bytes", "Parameter is null or empty.");
            }

            if (charIndex < 0)
            {
                throw new ArgumentOutOfRangeException("charIndex", "Parameter must be grater than or equal to zero.");
            }

            if (charCount < 0)
            {
                throw new ArgumentOutOfRangeException("charCount", "Parameter must be grater than or equal to zero.");
            }

            if (byteIndex < 0)
            {
                throw new ArgumentOutOfRangeException("byteIndex", "Parameter must be grater than or equal to zero.");
            }

            if (charIndex > chars.Length || (charIndex + charCount) > chars.Length)
            {
                throw new ArgumentOutOfRangeException("charIndex, charCount", "Index and/or count do not denote a valid range in chars.");
            }

            if (byteIndex > this.theTable.Length)
            {
                throw new ArgumentOutOfRangeException("byteIndex", "Index does not denote a valid range in chars.");
            }

            if ((charCount - charIndex) > (bytes.Length - byteIndex))
            {
                throw new ArgumentException("Bytes does not have enough capacity from byteIndex to the end of the array to accommodate the resulting bytes.");
            }

            #endregion // Parameter validation.

            int offset = byteIndex;

            for (int index = charIndex; index < (charIndex + charCount); index++)
            {
                bytes[offset++] = this.ByteFromCharacter(chars[index]);
            }

            return offset; // Return number of copied bytes!
        }

        public override int GetCharCount(byte[] bytes, int index, int count)
        {
            #region Parameter validation.

            if (bytes == null)
            {
                throw new ArgumentNullException("bytes", "Parameter is null or empty.");
            }

            if (index < 0)
            {
                throw new ArgumentOutOfRangeException("index", "Parameter must be grater than or equal to zero.");
            }

            if (count < 0)
            {
                throw new ArgumentOutOfRangeException("count", "Parameter must be grater than or equal to zero.");
            }

            if (index > this.theTable.Length || (index + count) > this.theTable.Length)
            {
                throw new ArgumentOutOfRangeException("index, count", "Index and/or count do not denote a valid range in bytes.");
            }

            #endregion // Parameter validation.

            return count - index;
        }

        public override int GetChars(byte[] bytes, int byteIndex, int byteCount, char[] chars, int charIndex)
        {
            #region Parameter validation.

            if (bytes == null)
            {
                throw new ArgumentNullException("bytes", "Parameter is null or empty.");
            }

            if (chars == null)
            {
                throw new ArgumentNullException("chars", "Parameter is null or empty.");
            }

            if (byteIndex < 0)
            {
                throw new ArgumentOutOfRangeException("byteIndex", "Parameter must be grater than or equal to zero.");
            }

            if (byteCount < 0)
            {
                throw new ArgumentOutOfRangeException("byteCount", "Parameter must be grater than or equal to zero.");
            }

            if (charIndex < 0)
            {
                throw new ArgumentOutOfRangeException("byteIndex", "Parameter must be grater than or equal to zero.");
            }

            if (byteIndex > bytes.Length || (byteIndex + byteCount) > bytes.Length)
            {
                throw new ArgumentOutOfRangeException("byteIndex, byteCount", "Index and/or count do not denote a valid range in chars.");
            }

            if (charIndex > this.theTable.Length)
            {
                throw new ArgumentOutOfRangeException("charIndex", "Index does not denote a valid range in chars.");
            }

            if ((byteCount - byteIndex) > (bytes.Length - charIndex))
            {
                throw new ArgumentException("Chars does not have enough capacity from byteIndex to the end of the array to accommodate the resulting bytes.");
            }

            #endregion // Parameter validation.

            int offset = byteIndex;

            for (int index = byteIndex; index < (byteIndex + byteCount); index++)
            {
                chars[offset++] = this.CharacterFromByte(bytes[index]);
            }

            return offset; // Return number of copied characters!
        }

        public override int GetMaxByteCount(int charCount)
        {
            #region Parameter validation.

            if (charCount < 0)
            {
                throw new ArgumentOutOfRangeException("charCount", "Parameter must be grater than or equal to zero.");
            }

            #endregion // Parameter validation.

            return charCount; // Number of bytes is identical to number of characters!
        }

        public override int GetMaxCharCount(int byteCount)
        {
            #region Parameter validation.

            if (byteCount < 0)
            {
                throw new ArgumentOutOfRangeException("byteCount", "Parameter must be grater than or equal to zero.");
            }

            #endregion // Parameter validation.

            return byteCount; // Number of characters is identical to number of bytes!
        }

        public byte ByteFromCharacter(char value)
        {
            // If character value equal to table index return this index value.
            if (value < this.theTable.Length)
            {
                return (byte)(value & 0x000000FF);
            }
            // Else try to find an index for given unicode character.
            else
            {
                for (int index = 0; index < this.theTable.Length; index++)
                {
                    if (this.theTable[index] == value)
                    {
                        return (byte)(index & 0x000000FF);
                    }
                }
            }
            throw new EncoderFallbackException("Could not encode character \"" + value + "\".");
        }

        public char CharacterFromByte(byte value)
        {
            try
            {
                return this.theTable[value];
            }
            catch (Exception inner)
            {
                throw new EncoderFallbackException("Could not encode byte \"" + value + "\".", inner);
            }
        }
    }
}
